# !usr/bin/env python
# coding=gbk
import math
import numpy
from scipy.fftpack import dct


# coding=utf-8
# ҪĸǷֱǣ
#    audio2frame:Ƶת֡
#    deframesignal:ÿһ֡һı任
#    spectrum_magnitude:ÿһ֡Ҷ任Ժķ
#    spectrum_power:ÿһ֡Ҷ任ԺĹ
#    log_spectrum_power:ÿһ֡Ҷ任ԺĶ
#    pre_emphasis:ԭʼźŽԤش



def audio2frame(signal, frame_length, frame_step, winfunc=lambda x: numpy.ones((x,))):
    '''ƵźתΪ֡
	壺
	signal:ԭʼƵͺ
	frame_length:ÿһ֡ĳ(ָĳȣƵʳʱ)
	frame_step:֡ļͬ϶壩
	winfunc:lambdaһ
    '''
    signal_length = len(signal)  # źܳ
    frame_length = int(round(frame_length))  # ֡֡ʱ䳤
    frame_step = int(round(frame_step))  # ֮֡Ĳ
    if signal_length <= frame_length:  # źųСһ֡ĳȣ֡Ϊ1
        frames_num = 1
    else:  # 򣬼֡ܳ
        frames_num = 1 + int(math.ceil((1.0 * signal_length - frame_length) / frame_step))
    pad_length = int((frames_num - 1) * frame_step + frame_length)  # ֡ܵƽĳ
    zeros = numpy.zeros((pad_length - signal_length,))  # ĳʹ0FFTе
    pad_signal = numpy.concatenate((signal, zeros))  # źżΪpad_signal
    indices = numpy.tile(numpy.arange(0, frame_length), (frames_num, 1)) + numpy.tile(
        numpy.arange(0, frames_num * frame_step, frame_step),
        (frame_length, 1)).T  # ൱ڶ֡ʱгȡõframes_num*frame_lengthȵľ
    indices = numpy.array(indices, dtype=numpy.int32)  # indicesתΪ
    frames = pad_signal[indices]  # õ֡ź
    win = numpy.tile(winfunc(frame_length), (frames_num, 1))  # windowĬȡ1
    return frames * win  # ֡źž


def deframesignal(frames, signal_length, frame_length, frame_step, winfunc=lambda x: numpy.ones((x,))):
    '''庯ԭźŵÿһ֡б任ӦΪ
    壺
    frames:audio2frameص֡
    signal_length:źų
    frame_length:֡
    frame_step:֡
    winfunc:ÿһ֡windowзĬϴ˴window
    '''
    # Բȡ
    signal_length = round(signal_length)  # źŵĳ
    frame_length = round(frame_length)  # ֡ĳ
    frames_num = numpy.shape(frames)[0]  # ֡
    assert numpy.shape(frames)[1] == frame_length, '"frames"СȷӦõһ֡'  # жframesά
    indices = numpy.tile(numpy.arange(0, frame_length), (frames_num, 1)) + numpy.tile(
        numpy.arange(0, frames_num * frame_step, frame_step),
        (frame_length, 1)).T  # ൱ڶ֡ʱгȡõframes_num*frame_lengthȵľ
    indices = numpy.array(indices, dtype=numpy.int32)
    pad_length = (frames_num - 1) * frame_step + frame_length  # ƽź
    if signal_length <= 0:
        signal_length = pad_length
    recalc_signal = numpy.zeros((pad_length,))  # ź
    window_correction = numpy.zeros((pad_length, 1))  # 
    win = winfunc(frame_length)
    for i in range(0, frames_num):
        window_correction[indices[i, :]] = window_correction[indices[i, :]] + win + 1e-15  # ʾźŵص̶
        recalc_signal[indices[i, :]] = recalc_signal[indices[i, :]] + frames[i, :]  # ԭźżص̶ȹɵź
    recalc_signal = recalc_signal / window_correction  # µĵźŵڵźŴÿص̶
    return recalc_signal[0:signal_length]  # ظµĵź


def spectrum_magnitude(frames, NFFT):
    '''ÿһ֡FFYԺƵ׵ķȣframesĴСΪN*L,򷵻ؾĴСΪN*NFFT
    ˵
    frames:audio2frameеķֵ֡
    NFFT:FFT任С,֡СNFFT֡ಿ0
    '''
    complex_spectrum = numpy.fft.rfft(frames, NFFT)  # framesFFT任
    return numpy.absolute(complex_spectrum)  # Ƶ׵ķֵ


def spectrum_power(frames, NFFT):
    '''ÿһ֡Ҷ任ԺĹ
    ˵
    frames:audio2frame֡
    NFFT:FFTĴС
    '''
    return 1.0 / NFFT * numpy.square(spectrum_magnitude(frames, NFFT))  # ׵ÿһķƽ/NFFT


def log_spectrum_power(frames, NFFT, norm=1):
    '''ÿһ֡Ĺ׵Ķʽ
    ˵
    frames:֡󣬼audio2frameصľ
    NFFTFFT任ĴС
    norm:һϵ
    '''
    spec_power = spectrum_power(frames, NFFT)
    spec_power[spec_power < 1e-30] = 1e-30  # Ϊ˷ֹֹ׵0Ϊ0޷ȡ
    log_spec_power = 10 * numpy.log10(spec_power)
    if norm:
        return log_spec_power - numpy.max(log_spec_power)
    else:
        return log_spec_power


def pre_emphasis(signal, coefficient=0.95):
    '''źŽԤ
    壺
    signal:ԭʼź
    coefficient:ϵĬΪ0.95
    '''
    return numpy.append(signal[0], signal[1:] - coefficient * signal[:-1])


# ÿһ֡MFCCϵ

# ȣΪ汾3.xҪxrangeʹãΪڰ汾2.xֻʹrangeҪxrange滻Ϊrange
try:
    xrange(1)
except:
    xrange = range


def calcMFCC_delta_delta(signal, samplerate=16000, win_length=0.025, win_step=0.01, cep_num=13, filters_num=26,
                         NFFT=512, low_freq=0, high_freq=None, pre_emphasis_coeff=0.97, cep_lifter=22,
                         appendEnergy=True):
    '''13MFCC+13һ΢ϵ+13ϵ,һ39ϵ
    '''
    feat = calcMFCC(signal, samplerate, win_length, win_step, cep_num, filters_num, NFFT, low_freq, high_freq,
                    pre_emphasis_coeff, cep_lifter, appendEnergy)  # Ȼȡ13һMFCCϵ
    result1 = derivate(feat)
    result2 = derivate(result1)
    result3 = numpy.concatenate((feat, result1), axis=1)
    result = numpy.concatenate((result3, result2), axis=1)
    return result


def calcMFCC_delta(signal, samplerate=16000, win_length=0.025, win_step=0.01, cep_num=13, filters_num=26, NFFT=512,
                   low_freq=0, high_freq=None, pre_emphasis_coeff=0.97, cep_lifter=22, appendEnergy=True):
    '''13MFCC+13һ΢ϵ
    '''
    feat = calcMFCC(signal, samplerate, win_length, win_step, cep_num, filters_num, NFFT, low_freq, high_freq,
                    pre_emphasis_coeff, cep_lifter, appendEnergy)  # Ȼȡ13һMFCCϵ
    result = derivate(feat)  # derivate
    result = numpy.concatenate((feat, result), axis=1)
    return result


def derivate(feat, big_theta=2, cep_num=13):
    '''һϵ߼ϵһ任ʽ
    ˵:
    feat:MFCCһϵ
    big_theta:ʽеĴthetaĬȡ2
    '''
    result = numpy.zeros(feat.shape)  # 
    denominator = 0  # ĸ
    for theta in numpy.linspace(1, big_theta, big_theta):
        denominator = denominator + theta ** 2
    denominator = denominator * 2  # õĸֵ
    for row in numpy.linspace(0, feat.shape[0] - 1, feat.shape[0]):
        row = int(row)
        tmp = numpy.zeros((cep_num,))
        numerator = numpy.zeros((cep_num,))  # 
        for t in numpy.linspace(1, cep_num, cep_num):
            t = int(t)
            a = 0
            b = 0
            s = 0
            for theta in numpy.linspace(1, big_theta, big_theta):
                theta = int(theta)
                if (t + theta) > cep_num:
                    a = 0
                else:

                    a = feat[row][t + theta - 1]
                if (t - theta) < 1:
                    b = 0
                else:
                    b = feat[row][t - theta - 1]
                s += theta * (a - b)
            numerator[t - 1] = s
        tmp = numerator * 1.0 / denominator
        result[row] = tmp
    return result


def calcMFCC(signal, samplerate=16000, win_length=0.025, win_step=0.01, cep_num=13, filters_num=26, NFFT=512,
             low_freq=0, high_freq=None, pre_emphasis_coeff=0.97, cep_lifter=22, appendEnergy=True):
    '''13MFCCϵ
    壺
    signal:ԭʼƵźţһΪ.wavʽļ
    samplerate:ƵʣĬΪ16KHz
    win_length:ȣĬϼһ֡Ϊ25ms
    win_step:Ĭ¼֡ʼʱ֮10ms
    cep_num:ϵĸĬΪ13
    filters_num:˲ĸĬΪ26
    NFFT:Ҷ任СĬΪ512
    low_freq:ƵʣĬΪ0
    high_freq:Ƶ
    pre_emphasis_coeff:ԤϵĬΪ0.97
    cep_lifter:׵
    appendEnergy:ǷĬϼ
    '''

    feat, energy = fbank(signal, samplerate, win_length, win_step, filters_num, NFFT, low_freq, high_freq,
                         pre_emphasis_coeff)
    feat = numpy.log(feat)
    feat = dct(feat, type=2, axis=1, norm='ortho')[:, :cep_num]  # ɢұ任,ֻȡǰ13ϵ
    feat = lifter(feat, cep_lifter)
    if appendEnergy:
        feat[:, 0] = numpy.log(energy)  # ֻȡ2-13ϵһĶ
    return feat


def fbank(signal, samplerate=16000, win_length=0.025, win_step=0.01, filters_num=26, NFFT=512, low_freq=0,
          high_freq=None, pre_emphasis_coeff=0.97):
    '''ƵźŵMFCC
    ˵
    samplerate:Ƶ
    win_length:
    win_step:
    filters_num:÷˲
    NFFT:FFTС
    low_freq:Ƶ
    high_freq:Ƶ
    pre_emphasis_coeff:Ԥϵ
    '''

    high_freq = high_freq or samplerate / 2  # ƵƵ
    signal = pre_emphasis(signal, pre_emphasis_coeff)  # ԭʼźŽԤش
    frames = audio2frame(signal, win_length * samplerate, win_step * samplerate)  # õ֡
    spec_power = spectrum_power(frames, NFFT)  # õÿһ֡FFTԺ
    energy = numpy.sum(spec_power, 1)  # ÿһ֡׽
    energy = numpy.where(energy == 0, numpy.finfo(float).eps, energy)  # Ϊ0ĵطΪepsڽж
    fb = get_filter_banks(filters_num, NFFT, samplerate, low_freq, high_freq)  # ÿһ˲Ƶʿ
    feat = numpy.dot(spec_power, fb.T)  # ˲׽е
    feat = numpy.where(feat == 0, numpy.finfo(float).eps, feat)  # ͬܳ0
    return feat, energy


def log_fbank(signal, samplerate=16000, win_length=0.025, win_step=0.01, filters_num=26, NFFT=512, low_freq=0,
              high_freq=None, pre_emphasis_coeff=0.97):
    '''ֵ
    壺ͬ
    '''
    feat, energy = fbank(signal, samplerate, win_length, win_step, filters_num, NFFT, low_freq, high_freq,
                         pre_emphasis_coeff)
    return numpy.log(feat)


def ssc(signal, samplerate=16000, win_length=0.025, win_step=0.01, filters_num=26, NFFT=512, low_freq=0, high_freq=None,
        pre_emphasis_coeff=0.97):
    '''
    
    '''
    high_freq = high_freq or samplerate / 2
    signal = pre_emphasis(signal, pre_emphasis_coeff)
    frames = audio2frame(signal, win_length * samplerate, win_step * samplerate)
    spec_power = spectrum_power(frames, NFFT)
    spec_power = numpy.where(spec_power == 0, numpy.finfo(float).eps, spec_power)  # 
    fb = get_filter_banks(filters_num, NFFT, samplerate, low_freq, high_freq)
    feat = numpy.dot(spec_power, fb.T)  # 
    R = numpy.tile(numpy.linspace(1, samplerate / 2, numpy.size(spec_power, 1)), (numpy.size(spec_power, 0), 1))
    return numpy.dot(spec_power * R, fb.T) / feat


def hz2mel(hz):
    '''ƵhzתΪ÷Ƶ
    ˵
    hz:Ƶ
    '''
    return 2595 * numpy.log10(1 + hz / 700.0)


def mel2hz(mel):
    '''÷ƵתΪhz
    ˵
    mel:÷Ƶ
    '''
    return 700 * (10 ** (mel / 2595.0) - 1)


def get_filter_banks(filters_num=20, NFFT=512, samplerate=16000, low_freq=0, high_freq=None):
    '''÷Ǽ˲˲ڵһƵʺ͵ƵʴΪ0ڵڶƵʴΪ1
    ˵
    filers_num:˲
    NFFT:FFTС
    samplerate:Ƶ
    low_freq:Ƶ
    high_freq:Ƶ
    '''
    # ȣƵhzתΪ÷ƵʣΪ˶ֱĴСƵʲȣԻΪ÷ƵԷָ
    low_mel = hz2mel(low_freq)
    high_mel = hz2mel(high_freq)
    # Ҫlow_melhigh_mel֮ȼfilters_num㣬һfilters_num+2
    mel_points = numpy.linspace(low_mel, high_mel, filters_num + 2)
    # ٽ÷ƵתΪhzƵʣҵӦhzλ
    hz_points = mel2hz(mel_points)
    # Ҫ֪Щhz_pointsӦfftеλ
    bin = numpy.floor((NFFT + 1) * hz_points / samplerate)
    # ˲ıʽˣÿ˲ڵһ㴦͵㴦Ϊ0мΪ״
    fbank = numpy.zeros([filters_num, NFFT / 2 + 1])
    for j in xrange(0, filters_num):
        for i in xrange(int(bin[j]), int(bin[j + 1])):
            fbank[j, i] = (i - bin[j]) / (bin[j + 1] - bin[j])
        for i in xrange(int(bin[j + 1]), int(bin[j + 2])):
            fbank[j, i] = (bin[j + 2] - i) / (bin[j + 2] - bin[j + 1])
    return fbank


def lifter(cepstra, L=22):
    '''׺
    ˵
    cepstra:MFCCϵ
    LϵĬΪ22
    '''
    if L > 0:
        nframes, ncoeff = numpy.shape(cepstra)
        n = numpy.arange(ncoeff)
        lift = 1 + (L / 2) * numpy.sin(numpy.pi * n / L)
        return lift * cepstra
    else:
        return cepstra